import es
import gamethread
import random
import vecmath

dmg_attacks = {}
dmg_counter = 0
# victim (person taking damage, also used for area effect)
#attacker (person dealing damage)
#damage (ammount of damage)
#type (type of damage)
#interval (how often the damage triggers)
#delay (how long the damage lasts for)
#radius (radius of the damage)
class directdmg:
	"Extensive Class for Using point_hurt"
	def __init__(self, dmg_userid):
		if dmg_userid == 0:
			dmg_userid = es.getuserid()
		self.userid = int(dmg_userid)
	
	#Damage System (point_hurt)
	def hurt(self,victim,damage=1,type=2,weapon='point_hurt',interval=0.0,delay=0.0,radius=0,dmg_ff=0):
		global dmg_attacks, dmg_counter
		dmg_counter += 1
		if dmg_counter > 9999:
			dmg_counter = 1
		if victim and damage > 0:
			dmg_number = str(dmg_counter)
			dmg_name = 'skill_damage_' + dmg_number
			es.server.cmd('es_give ' + str(victim) + ' point_hurt')
			es.server.queuecmd('es_fire ' + str(victim) + ' !self addoutput \"targetname badboy' + dmg_number + '\"')
			es.server.queuecmd('est_setentname ' + es.getString('eventscripts_lastgive') + ' ' + dmg_name)
			es.server.queuecmd('es_fire ' + str(victim) + ' ' + dmg_name + ' addoutput \"Damage ' + str(damage) + '\"')
			es.server.queuecmd('es_fire ' + str(victim) + ' ' + dmg_name + ' addoutput \"DamageType ' + str(type) + '\"')
			es.server.queuecmd('es_fire ' + str(victim) + ' ' + dmg_name + ' addoutput \"DamageDelay ' + str(interval) + '\"')
			if not dmg_ff:
				team = es.getplayerteam(self.userid)
				es.setindexprop(es.getInt('eventscripts_lastgive'),'CBaseEntity.m_iTeamNum',team)
			if radius:
				es.server.queuecmd('es_fire ' + str(victim) + ' ' + dmg_name + ' addoutput \"DamageRadius ' + str(radius) + '\"')
				dmg_vec = vecmath.vector(es.getplayerlocation(victim))
				dmg_vec['z'] += 45.0
				es.server.queuecmd('es_fire ' + str(victim) + ' ' + dmg_name + ' addoutput \"origin ' + str(dmg_vec['x']) + ' ' + str(dmg_vec['y']) + ' ' + str(dmg_vec['z']) + '\"') 
				es.server.queuecmd('es_fire ' + str(victim) + ' ' + dmg_name + ' TurnOn')
				es.server.queuecmd('es_fire ' + str(victim) + ' targetname notbad')
				gamethread.delayed(delay,self.__delayed_off,(str(victim),str(dmg_name)))
			else:
				if weapon != 'point_hurt':
					dmg_attacks[int(victim)] = weapon
				if victim != self.userid:
					es.server.queuecmd('es_fire ' + str(self.userid) + ' ' + dmg_name + ' addoutput \"DamageTarget badboy' + dmg_number + '\"')
				if delay:
					es.server.queuecmd('es_fire ' + str(self.userid) + ' ' + dmg_name + ' TurnOn')
					gamethread.delayed(delay,self.__delayed_off,(victim,dmg_name))
				else:
					es.server.queuecmd('es_fire ' + str(self.userid) + ' ' + dmg_name + ' Hurt')
					es.server.queuecmd('es_fire ' + str(victim) + ' ' + dmg_name + ' kill')
					es.server.queuecmd('es_fire ' + str(victim) + ' targetname notbad')
			
	def radius(self,damage=1,type=2,weapon='point_hurt',interval=0.0,delay=0.0,radius=0,dmg_ff=0):
		if radius == 0:
			return 0
		if damage < 1:
			damage = 1
		if type < 0:
			type = 0
		if interval <= 0.0:
			interval = 0.1
		if delay <= 0.0:
			delay = 0.1
		if weapon == '':
			weapon = 'point_hurt'
		self.hurt(self.userid,damage,type,weapon,interval,delay,radius,dmg_ff)
		
	def point(self,victim,damage=1,type=2,weapon='point_hurt',dmg_ff=0):
		if victim < 2:
			victim = es.getuserid()
		if damage < 1:
			damage = 1
		if type < 0:
			type = 0
		if weapon == '':
			weapon = 'point_hurt'
		self.hurt(victim,damage,type,weapon,0.0,0.0,0,dmg_ff)
		
	def repeat(self,victim,damage=1,type=2,weapon='point_hurt',interval=0.0,delay=0.0,dmg_ff=0):
		if victim < 2:
			victim = es.getuserid()
		if damage < 1:
			damage = 1
		if type < 0:
			type = 0
		if interval <= 0.0:
			interval = 0.1
		if delay <= 0.0:
			delay = 0.1
		if weapon == '':
			weapon = 'point_hurt'
		self.hurt(self.userid,damage,type,weapon,interval,delay,0,dmg_ff)
		
	def __delayed_off(self,victim,dmg_name):
		es.server.queuecmd('es_fire ' + str(victim) + ' ' + dmg_name + ' TurnOff')
		es.server.queuecmd('es_fire ' + str(victim) + ' ' + dmg_name + ' kill')
		es.server.queuecmd('es_fire ' + str(victim) + ' targetname notbad')
		
def get(userid):
	return directdmg(userid)
				
def dmg_check_attacks(dmg_userid):
	if dmg_attacks.has_key(int(dmg_userid)):
		dmg_tmp = dmg_attacks[int(dmg_userid)]
		if dmg_tmp == 'env_explosion':
			return 'suicide_explosion'
		return dmg_tmp
	else:
		return '0'
		
def dmg_remove_attacks(dmg_userid):
	global dmg_attacks
	if dmg_attacks.has_key(int(dmg_userid)):
		del dmg_attacks[int(dmg_userid)]